<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2018 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_klarna_kco/classes/constants.php';


class callback_xt_klarna_kco extends callback
{

    var $log_callback = true;


    function process()
    {
        global $filter, $db, $tax, $countries, $xtLink, $store_handler, $customers_status, $xtPlugin;
        global $debug_ip;

        $this->data = array();
        $raw_data = file_get_contents("php://input");
        klarna_kco::log('callback process', array('_REQUEST' => $_REQUEST, 'php_input' => $raw_data), null);


        $allowed_events = array('shipping_address_change', 'shipping_address_update', 'validation', 'push', 'notification', 'change', 'set_comment','shipping_option_change');
        $response = '';
        $location = '';

        try
        {
            $event = isset($_REQUEST['event']) ? $_REQUEST['event'] : false;

            if ($event!==false && in_array($event, $allowed_events))
            {
                switch ($event)
                {
                    /**
                     *   frontend events
                     */
                    case 'set_comment':

                        try
                        {
                            $_SESSION['order_comments'] = $_POST['comments'];
                        }
                        catch(Exception $ex)
                        {
                            error_log('klarna callback set_comment => '.$ex->getMessage());
                        }

                        $header = '201';
                        break;

                    case 'shipping_option_change':

                        try
                        {
                            if($_REQUEST['id'] != $_SESSION['kco_selected_shipping'])
                            {
                                $kco_order = klarna_kco::getCheckoutOrder($_SESSION['kco_order_id']);
                                if($kco_order['status'] == 'checkout_complete')
                                {
                                    // should not happen, but for some reason we have an completed order
                                    throw new Exception('order in status completed,. creating new one');
                                }
                                if (!is_array($kco_order['shipping_options']) || count($kco_order['shipping_options'])==0 || $kco_order['shipping_options'][0]['id'] == 'SHIPPING_NOT_AVAILABLE')
                                {
                                    $errors[] = array('key' => 'NO_SHIPPING_FOUND', 'shipping_country' => $_SESSION['kco_shipping_country']);
                                }

                                $errors = array();

                                //$csspt = (int) $db->GetOne('SELECT customers_status_show_price_tax from '.TABLE_CUSTOMERS_STATUS.' WHERE customers_status_id = ?', array($_SESSION['customer']->customers_status));

                                $urls =  xt_klarna_kco::getCallbackUrls();

                                $_SESSION['kco_selected_shipping'] = $_SESSION['selected_shipping'] = $_REQUEST['id'];

                                klarna_kco::updateOrderAmounts($kco_order, $_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $_SESSION['kco_shipping_country'], $errors);


                            }
                            $response = array('kco_selected_shipping' => $_REQUEST['id']);
                        }
                        catch(Exception $ex)
                        {
                            error_log('klarna callback shipping_option_change => '.$ex->getMessage());

                            $msg = 'An error occured:';
                            $details = $ex->getMessage();
                            $html = '<div class="alert alert-danger klarna-error" role="alert"><p class="item"><span class="glyphicon glyphicon-exclamation-sign"></span>&nbsp;&nbsp;'.$msg.'</p><p style="font-size:0.8em">'.$details.'</p></div>';
                            $response = array('error_html' => $html);
                        }

                        $header = '201';
                        break;

                    //case 'country_change':
                    case 'change':
                    case 'shipping_address_change':

                        $session_kco_shipping_country = $_SESSION['kco_shipping_country'];
                        $iso2 = klarna_kco::convert_country_code(strtoupper($_REQUEST['country']), true);

                        $country_data = $countries->_getCountryData($iso2);
                        $_SESSION['customer']->customer_shipping_address = array();
                        $_SESSION['customer']->customer_shipping_address['customers_country_code'] = $iso2;
                        $_SESSION['customer']->customer_shipping_address['customers_zone'] = $country_data['zone_id'];

                        $errors = array();

                        if($session_kco_shipping_country != $iso2)
                        {
                            global $_content;
                            $content_array_agb = $_content->getHookContent(3);
                            $content_array_rsc = $_content->getHookContent(8);

                            $urls = array(
                                'push'                  => $xtLink->_link(array('page' => 'callback', 'paction' => 'xt_klarna_kco', 'conn'=>'SSL')),
                                'confirmation_klarna'   => $xtLink->_link(array('page' => 'checkout', 'paction' => 'process', 'conn'=>'SSL')),
                                'confirmation_shop'     => $xtLink->_link(array('page' => 'checkout', 'paction' => 'confirmation', 'conn'=>'SSL')),
                                'terms'                 => $content_array_agb["content_link"],
                                'cancellation_terms'    => $content_array_rsc["content_link"]
                            );

                            $kco_order = klarna_kco::getCheckoutOrder($_REQUEST['kco_order_id']);

                            //$csspt = (int) $db->GetOne('SELECT customers_status_show_price_tax from '.TABLE_CUSTOMERS_STATUS.' WHERE customers_status_id = ?', array($_SESSION['customer']->customers_status));

                            $return = [];
                            klarna_kco::updateOrderAmounts($kco_order, $_SESSION['cart'], $_SESSION['customer'], $customers_status, $urls, $iso2, $errors, $return);

                            $_SESSION['kco_shipping_country'] = $iso2;
                        }

                        header($_SERVER["SERVER_PROTOCOL"].' 200', false, 200);
                        header('Content-Type: application/json');

                        $kco_shipping_country_iso3 = strtolower(klarna_kco::convert_country_code($_SESSION['kco_shipping_country']));

                        if($event == 'shipping_address_change')
                        {
                            $_SESSION['separate_shipping_country'] =  $_REQUEST['country'];
                        }

                        if(count($errors))
                        {
                            $html = '';

                            foreach($errors as $error)
                            {
                                $msg = TEXT_KLARNA_GENERAL_ERROR;
                                $details = '';
                                if(is_array($error))
                                {
                                    switch($error['key'])
                                    {
                                        case 'NO_SHIPPING_FOUND':
                                            if($_SESSION['cart']->type != 'virtual')
                                            {
                                                $msg = WARNING_NO_SHIPPING_FOR_ZONE;
                                                global $system_shipping_link;
                                                $shipping_link = $system_shipping_link->shipping_link;
                                                if ($shipping_link != '')
                                                {
                                                    $msg .= ' <a href="' . $shipping_link . '">' . TEXT_SHIPPING_COSTS . '</a>';
                                                }
                                                $details = TEXT_COUNTRY . ': ' . $error['shipping_country'] . ' &nbsp; ' . TEXT_SUB_TOTAL . ': ' . $_SESSION['cart']->content_total['formated'];
                                            }
                                            break;
                                    }
                                }

                                $html .= '<div class="alert alert-danger klarna-error" role="alert"><p class="item"><span class="glyphicon glyphicon-exclamation-sign"></span>&nbsp;&nbsp;'.$msg.'</p><p style="font-size:0.8em">'.$details.'</p></div>';
                            }

                            echo json_encode(array(
                                'error_html' => $html,
                                'kco_shipping_country' => $kco_shipping_country_iso3,
                                'kco_separate_shipping_country' => $_SESSION['separate_shipping_country']
                            ));
                            exit;
                        }
                        else{
                            echo json_encode(array(
                                'kco_shipping_country' => $kco_shipping_country_iso3,
                                'kco_separate_shipping_country' => $_SESSION['separate_shipping_country']
                            ));
                        }


                        break;

                    /**
                     * klarna callback events
                     */
                    case 'validation':

                        ($plugin_code = $xtPlugin->PluginCode('callback_klarna_kco:validation_top')) ? eval($plugin_code) : false;

                        $kco_order_id = $_REQUEST['kco_order_id'];
                        if(empty($kco_order_id)) throw new Exception('kco order id not found in request');

                        $header = '200';

                        $kco_order = json_decode($raw_data, true);

                        // check login
                        if(empty($_REQUEST['registered_customer']))
                        {
                            $sql = "SELECT customers_id FROM " . TABLE_CUSTOMERS . " where customers_email_address = ? and account_type = '0'";
                            $sql_ar = array($kco_order['billing_address']['email']);
                            $check_shop_id = true;
                            if($check_shop_id)
                            {
                                $sql .= " AND shop_id=? ";
                                $sql_ar[] = $store_handler->shop_id;
                            }

                            $record = $db->Execute($sql, $sql_ar);

                            if($record->RecordCount() > 0)
                            {
                                $msg = htmlentities(sprintf(TEXT_KLARNA_HELLO_PLEASE_LOGIN, $kco_order['billing_address']['email']));

                                header($_SERVER["SERVER_PROTOCOL"].' 400 Bad Request', false, 400);
                                header('Content-Type: text/plain; charset=UTF-8');

                                echo '{ "error_type": "address_error", "error_text": "'.$msg.'"}';
                                exit;
                            }
                        }
                        else
                        {
                            $sql = "SELECT customers_email_address FROM " . TABLE_CUSTOMERS . " where customers_id = ? and account_type = '0'";
                            $sql_ar = array($_REQUEST['registered_customer']);
                            $check_shop_id = true;
                            if($check_shop_id)
                            {
                                $sql .= " AND shop_id=? ";
                                $sql_ar[] = $store_handler->shop_id;
                            }

                            $email = $db->GetOne($sql, $sql_ar);

                            if(!empty($email) && $email != $kco_order['billing_address']['email'])
                            {
                                $msg = htmlentities(sprintf(TEXT_KLARNA_HELLO_PLEASE_LOGOUT, $email , $kco_order['billing_address']['email']));

                                header($_SERVER["SERVER_PROTOCOL"].' 400 Bad Request', false, 400);
                                header('Content-Type: text/plain; charset=UTF-8');

                                echo '{ "error_type": "address_error", "error_text": "'.$msg.'"}';
                                exit;
                            }
                        }


                        if(is_array($kco_order) && is_array($kco_order['order_lines']))
                        {
                            // stock check
                            global $db;
                            $stock = new stock();
                            foreach($kco_order['order_lines'] as $ol)
                            {
                                $skip_types = ['discount'];
                                ($plugin_code = $xtPlugin->PluginCode('callback_klarna_kco:validation_foreach_order_line_top')) ? eval($plugin_code) : false;

                                if (in_array($ol['type'], $skip_types)) continue;

                                $quantity = $db->GetOne('SELECT products_quantity FROM '.TABLE_PRODUCTS.' WHERE products_model=?', array($ol['reference']));
                                $check_data = new stdClass();
                                $check_data->data = array(
                                    'products_quantity' =>  $quantity,
                                    'products_name' => $ol['name'],
                                );
                                $new_stock = $stock->stockCheck($check_data, $ol['quantity'], false);
                                if ($new_stock < $ol['quantity'])
                                {

                                    header($_SERVER["SERVER_PROTOCOL"].' 400 Bad Request', false, 400);
                                    header('Content-Type: text/plain; charset=UTF-8');

                                    $msg = TEXT_KLARNA_STOCK_ERROR;

                                    echo '{ "error_type": "address_error", "error_text": "'.$msg.'"}';
                                    exit;
                                }
                                ($plugin_code = $xtPlugin->PluginCode('callback_klarna_kco:validation_foreach_order_line_bottom')) ? eval($plugin_code) : false;
                            }

                            // check shipping
                            $shipping_country = $kco_order['shipping_address']['country'];

                            if (!is_array($kco_order['shipping_options']) || count($kco_order['shipping_options'])==0 || $kco_order['shipping_options'][0]['id'] == 'SHIPPING_NOT_AVAILABLE')
                            {
                                // testen ob evtl cart virtual
                                $virtual = true;
                                foreach($kco_order['order_lines'] as $order_line)
                                {
                                    if($order_line['type'] != 'digital')
                                    {
                                        $virtual = false;
                                        break;
                                    }
                                }
                                if(!$virtual)
                                {
                                    $msg = constant("WARNING_NO_SHIPPING_FOR_ZONE");
                                    global $system_shipping_link, $price;
                                    $shipping_link = $system_shipping_link->shipping_link;
                                    if ($shipping_link != '')
                                    {
                                        //$msg .= '<br /><a href="'.$shipping_link.'">'.TEXT_SHIPPING_COSTS.'</a>';
                                    }
                                    $details = TEXT_COUNTRY . ': ' . strtoupper($shipping_country) . ' / ' . TEXT_SUB_TOTAL . ': ' . $price->_StyleFormat($kco_order['order_amount'] / 100);

                                    header($_SERVER["SERVER_PROTOCOL"] . ' 400 Bad Request', false, 400);
                                    header('Content-Type: text/plain; charset=UTF-8');

                                    echo '{ "error_type": "address_error", "error_text": "' . $msg . '  ' . $details . '"}';
                                    exit;
                                }
                            }
                        }

                        ($plugin_code = $xtPlugin->PluginCode('callback_klarna_kco:validation_bottom')) ? eval($plugin_code) : false;

                        break;

                    case 'notification':

                        $kco_order_id = $_REQUEST['kco_order_id'];
                        if(empty($kco_order_id)) throw new Exception('kco order id not found in request');

                        $kco_order = klarna_kco::getOrder($kco_order_id);
                        klarna_kco::setKlarnaOrderIdInXt($kco_order, $kco_order['merchant_reference1']);

                        $header = '201';
                        break;

                    case 'push':

                        $kco_order_id = $_REQUEST['kco_order_id'];
                        if(empty($kco_order_id)) throw new Exception('kco order id not found in request');

                        /**
                         * save klarnas order id in db
                         */
                        $klarna_order = klarna_kco::getKlarnaOrderFromXt(false, $kco_order_id);
                        if(!is_array($klarna_order))
                        {
                            klarna_kco::cancelOrder($kco_order_id);
                            error_log("kco push | kco order [$kco_order_id] not found in xt. order was canceled");
                            $header = '201';
                        }
                        else
                        {
                            $xt_order_id = $db->GetOne("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE kco_order_id=?", array($kco_order_id));

                            /**
                             * acknowledge order in klarna and set merchant ref1 to xt's order id
                             */
                            klarna_kco::setXtOrderIdInKlarna($kco_order_id, $xt_order_id);
                            klarna_kco::acknowledgeOrder($kco_order_id);
                            /**
                             * fetch klarna order an save in xt db
                             */
                            $order_management = klarna_kco::getOrder($kco_order_id);
                            klarna_kco::setKlarnaOrderInXt($order_management, $xt_order_id);

                            $header = '201';
                        }
                        break;

                    default:
                        throw new Exception('event ['.$event.'] not implemented');
                }

                if(!empty($location))
                {
                    header('Location: /'.$location, false, $header);
                }
                else if(!empty($response))
                {
                    header("HTTP/1.1", false, $header);
                    header('Content-Type: application/json');
                    echo json_encode($response);
                }
                else {
                    header("HTTP/1.1", false, $header);
                }

            }
            else {
                if (empty($event))
                {
                    $msg = 'Event parameter empty';
                }
                else if (!in_array($event, $allowed_events))
                {
                    $msg = 'Event ['.$event.'] not allowed';
                }
                else
                {
                    $msg = 'No event parameter';
                }
                throw new Exception($msg);
            }
        }
        catch (Exception $e)
        {
            $event = $event.' ' ?: ' ';
            klarna_kco::log('callback process error', $_REQUEST, array(), $e);
            error_log("kco callback $event| ".$e->getMessage());
            header("HTTP/1.1 500");
        }

    }

}
